
#include <boost/graph/undirected_graph.hpp>
#include <boost/graph/undirected_dfs.hpp>
#include <boost/graph/graphviz.hpp>

#include <iostream>

using graph_t=boost::undirected_graph<>;

struct visitor_t : public boost::default_dfs_visitor {
   template<typename vertex_t, typename graph_t>
   void discover_vertex(const vertex_t &v, const graph_t &g) const { 
     std::cerr << v << std::endl; 
   }
};

int main() {
  graph_t g;

  auto v0 = g.add_vertex();
  auto v1 = g.add_vertex();
  auto v2 = g.add_vertex();
  auto v3 = g.add_vertex();

  std::cout << v0 << std::endl;
  std::cout << v1 << std::endl;
  std::cout << v2 << std::endl;
  std::cout << v3 << std::endl;

  g.add_edge(v0,v1);
  g.add_edge(v0,v2);
  g.add_edge(v1,v3);

  visitor_t vis;
  boost::depth_first_search(g, boost::visitor(vis));

  write_graphviz(std::cout, g);

  return 0;
}
