// naumann@stce.rwth-aachen.de

#include<fstream>
#include<iostream>

template<typename VT, typename ET>
graph<VT,ET>::graph(char* filename) {
  std::ifstream ifs(filename);
  int n,m; // numbers of vertices and edges
  ifs >> n >> m;
  // insert vertices
  for (int i=0;i<n;i++) vertices.push_back(new VT);
  // insert edges
  int src, tgt;
  for (int i=0;i<m;i++) {
    ifs >> src >> tgt;
    edges.push_back(new ET(vertices[src],vertices[tgt]));
  }
}

template<typename VT, typename ET>
graph<VT,ET>::~graph() {
  for (auto &v : vertices) delete v;
  for (auto &e : edges) delete e;
}

template<typename VT, typename ET>
void graph<VT,ET>::to_dot() const {
  std::cout <<"graph {" << std::endl;
  std::cout <<"rankdr=\"LR\"" << std::endl;
  for (auto v_it=vertices.begin();v_it!=vertices.end();v_it++) 
    std::cout << (*v_it)->index() << std::endl;
  for (auto e_it=edges.begin();e_it!=edges.end();e_it++) 
    std::cout << (*e_it)->src->index() << "--" << (*e_it)->tgt->index() << std::endl;
  std::cout <<"}" << std::endl;
}
