// naumann@stce.rwth-aachen.de

#include<vector>
#include<list>

template<typename VT, typename ET>
class graph {
  std::vector<VT*> vertices;
  std::list<ET*> edges;
public:
  graph(char*); 
  ~graph(); 
  size_t num_vertices() const;
  size_t num_edges() const;
  vertex& get_vertex(size_t) const;
  void to_dot() const;
  void unvisit() const;
  void dfs(VT&) const;
  void dfs(VT&,void(*)(const VT&)) const;
private:
  graph();
  graph(const graph&);
  graph& operator=(const graph&);
};

#include "graph.cpp"
